#include "bnr_internal.h"
#include "parseclicks.h"

/* returns the members of the click that rank belongs to in a group, valid click names are: shm, tcp, and via */
MPICH_BNR_API int BNR_Get_click(BNR_gid group, char *clickname, int rank, int *num, int **members)
{
	char pszClickString[1024] = "";

	if (clickname == NULL || num == NULL || members == NULL || group == BNR_INVALID_GROUP)
		return BNR_FAIL;
	if (group == BNR_GROUP_NULL)
	{
		*num = 0;
		*members = NULL;
		return BNR_SUCCESS;
	}
	if (rank < 0 || rank >= ((BNR_Group_node*)group)->nSize)
		return BNR_FAIL;

	if (stricmp("tcp", clickname) == 0)
	{
		strcpy(pszClickString, "*");
	}
	else if (stricmp("shm", clickname) == 0)
	{
		if (!GetEnvironmentVariable("BNR_SHM_CLICKS", pszClickString, 1024))
		{
			*num = 1;
			*members = new int[1];
			(*members)[0] = rank;
			return BNR_SUCCESS;
		}
	}
	else if (stricmp("via", clickname) == 0)
	{
		if (!GetEnvironmentVariable("BNR_VIA_CLICKS", pszClickString, 1024))
		{
			*num = 0;
			*members = NULL;
			return BNR_SUCCESS;
		}
	}
	else
	{
		return BNR_FAIL;
	}

	if (ParseClicks(pszClickString, rank, ((BNR_Group_node*)group)->nSize, num, members) == 0)
		return BNR_SUCCESS;
	else
		return BNR_FAIL;
}
